unit fmFont;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ImageAspect, RXSplit, AboutDialog;

type
  TfmMain = class(TForm)
    odOpen: TOpenDialog;
    sdSave: TSaveDialog;
    panLeftbar: TPanel;
    Image1: TImageAspect;
    panInfo: TPanel;
    panMemo: TPanel;
    Memo1: TMemo;
    panButtons: TPanel;
    btLoad: TButton;
    btConv: TButton;
    btSave: TButton;
    edHSz: TEdit;
    edVSz: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    btCancel: TButton;
    RxSplitter1: TRxSplitter;
    adAbout: TAboutDialog;
    procedure btLoadClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure btConvClick(Sender: TObject);
    procedure btCancelClick(Sender: TObject);
    procedure panInfoDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    GlobalCancel   : Boolean;
    GlobalFilename : string;
  end;

var
  fmMain: TfmMain;

implementation

{$R *.DFM}

procedure TfmMain.btLoadClick(Sender: TObject);
begin
  if odOpen.Execute then
  begin
    GlobalFilename := odOpen.Filename;
    Image1.Picture.Bitmap.LoadFromFile(odOpen.Filename);
  end;
end;

procedure TfmMain.btSaveClick(Sender: TObject);
begin
  if sdSave.Execute then
    Memo1.Lines.SaveToFile(sdSave.Filename);
end;

procedure TfmMain.btConvClick(Sender: TObject);
var
  X, Y, A, B : Word;
  S          : string;
  szx, szy   : Word;
  C          : Word;
begin
  C := 0;
  btCancel.Enabled := True;
  szx := StrToInt(edHSz.Text);
  szy := StrToInt(edVSz.Text);
  Memo1.Clear;
  Memo1.Lines.Add('# Created using FontConv 1.00 by P. Pemberton');
  Memo1.Lines.Add('# See http://www.philpem.f9.co.uk for more info');
  Memo1.Lines.Add('# Converted from ' + GlobalFilename);
  Memo1.Lines.Add('');
  Memo1.Lines.Add('');
  for A := 0 to (Image1.Picture.Width div szX) - 1      do
    for B := 0 to (Image1.Picture.Height div szY)-1     do
    begin
      for Y := (B * szY) + 0 to (B * szY) + (szY - 1)   do  {Vertical loop}
      begin
        S := '';
        for X := (A * szX) + 0 to (A * szX) + (szX - 1) do  {Horizontal Loop}
        begin
          Application.ProcessMessages;
          if GlobalCancel then
          begin
            GlobalCancel := False;
            btCancel.Enabled := False;
            Memo1.Lines.Add('Conversion cancelled at user''s request.');
            Exit;
          end;
          if (Image1.Picture.Bitmap.Canvas.Pixels[X, Y] and $00FFFFFF) <> 0 then
            S := S + '1' else
            S := S + '0';
        end;
        Memo1.Lines.Add(S);
        C := C + 1;
      end;
      Memo1.Lines.Add('');
    end;
  btCancel.Enabled := False;
  Memo1.Lines[3] := IntToStr(C div StrToInt(edVSz.Text));
  Memo1.Lines[4] := edVSz.Text;
  Memo1.Lines[0] := Memo1.Lines[0];
end;

procedure TfmMain.btCancelClick(Sender: TObject);
begin
  GlobalCancel := True;
end;

procedure TfmMain.panInfoDblClick(Sender: TObject);
begin
  adAbout.Execute;
end;

end.
