function Bin8ToInt ( X : String ) : Integer;

{ Purpose : Converts an 8-bit Binary "Number" to an Integer.                 }
{           The 8-bit "Number" is really an 8-character string, or at least  }
{           it should be.                                                    }

CONST
     Bits8 : Array [1..8] of Integer = (128, 64, 32, 16, 8, 4, 2, 1);

VAR
   G, Total : Integer;

Begin
     Total := 0;
     For G := 1 to 8 Do
         If ( X[G] = '1' ) then
            Total := Total + Bits8[G];
     Bin8ToInt := Total;
End;                                        { FUNCTION Conversions.Bin8ToInt }

function StrToInt(S : string) : Integer;
var
  V, Code : Integer;
begin
  Val(S, V, Code);
  StrToInt := V;
end;

var
  B : Byte;
  S : string;
  T : Text;
  F : Text;
  C : Word;

  FLen : Word;
begin
  WriteLn('FME to INC converter');
  WriteLn('By P. A. Pemberton. See www.philpem.f9.co.uk for more of my creations.');
  WriteLn('E-mail: philpem@bigfoot.com');
  if ParamCount < 3 then
  begin
    WriteLn('Syntax:');
    WriteLn('  FME2INC filein fileout constname');
    WriteLn('filein and fileout are the input and output files respectively.');
    WriteLn('constname is the name of the constant that will be written to the');
    WriteLn('Pascal include file (fileout).');
    WriteLn;
    WriteLn('InFile format:');
    WriteLn('  Comments can be placed anywhere in the file - they begin with a hash (#)');
    WriteLn('  First non-comment line is the number of characters in the file.');
    WriteLn('  Second non-comment line is the font height in pixels.');
    WriteLn('  All lines after that are classified as font data and are stored in binary');
    WriteLn('  (ex: 01010101 = half filled).');
    WriteLn('  Blank lines are ignored.');
    WriteLn('  Files created with BMP2FME can be run straight through FME2INC.');
    WriteLn('  The last line in the file MUST NOT be blank (if it is you''ll have');
    WriteLn('  an extra ", " at the end of your data array)! BMP2FME data files are OK as-is.');
    Exit;
  end;
  Assign(F, ParamStr(1));
  Reset(F);
  Assign(T, ParamStr(2));
  Rewrite(T);

  C := 0;
  WriteLn(T, 'const');

  repeat
    ReadLn(F, S);
  until S[1] <> '#';

  FLen := StrToInt(S);
  WriteLn(T, '  ', ParamStr(3), 'Len = ', FLen, ';');

  repeat
    ReadLn(F, S);
  until S[1] <> '#';

  WriteLn(T, '  ', ParamStr(3), ' : array[0..', (FLen * StrToInt(S)) - 1, '] of Byte =');
  Write(T, ' (');
  repeat
    ReadLn(F, S);
    B := Bin8ToInt(S);
    if Length(S) > 0 then
    begin
      if not EOF(F) then Write(T, B:3, ', ');
      C := C + 1;
    end;
    if C = 16 then
    begin
      WriteLn(T);
      Write(T, '  ');
      C := 0;
    end;
  until EOF(F);

  WriteLn(T, ');');

  Close(F);
  Close(T);
end.