uses
  DOS;

{Include file with logo in it}
{$I KNGTWULF.INC}

procedure PutFontC (C : Byte; var Data);
  {-Define font character bitmap}
begin
  inline($FA);
  PortW[$3C4]:=$0402;
  PortW[$3C4]:=$0704;
  PortW[$3CE]:=$0204;
  PortW[$3CE]:=$0005;
  PortW[$3CE]:=$0006;
  Move(Data, Mem[SegA000:C * 32], 16);
  PortW[$3C4]:=$0302;
  PortW[$3C4]:=$0304;
  PortW[$3CE]:=$0004;
  PortW[$3CE]:=$1005;
  PortW[$3CE]:=$0E06;
  inline($FB);
end;

procedure PutFont(C : Byte; Count : Byte; var Data);
{Load the font data into memory}
var
  Cnt : Byte;
  Pnt : Pointer;
begin
  for Cnt := C to C + Count do
  begin
    Pnt := Ptr(Seg(Data), Ofs(Data) + ((Cnt-C) * 16));
    PutFontC(Cnt, Pnt^);
  end;
end;

procedure SetCharWidth( hwidth : byte );
{Set character width}
var
  x    : byte;                        { Value for misc. output reg. }
begin
  asm
    cmp         hwidth, 8
    je          @hweq
    mov         bx,     0800h
    jmp         @done

  @hweq:
    mov         bx,     0001h
  @done:

    mov         dx,     03cch
    in          al,     dx
    and         al,     0f3h
    mov         [x],    al

    cmp         hwidth, 9
    je          @hwequ
    jmp         @over

  @hwequ:
    mov         al,     [x]
    or          al,     4
    mov         [x],    al

  @over:

     mov        al,     [x]
     mov        dx,     03c2h
     out        dx,     al

     cli
     mov        dx,     03c4h
     mov        ax,     0100h
     out        dx,     ax

     mov        ax,     0000h
     mov        al,     bl
     shl        ax,     8
     inc        ax
     mov        dx,     03c4h
     out        dx,     ax

     mov        dx,     03c4h
     mov        ax,     0300h
     out        dx,     ax
     sti

     mov        ax,     1000h
     mov        bl,     13h
     int        10h
  end;
end;

(*
{ This is Pedro Correia's routine - comment out the above one and
  uncomment this one to see the difference (none).                }
procedure SetCharWidth( hwidth : byte );

var Regs : Registers;        { Processor registers for interrupt call }
    x    : byte;                        { Value for misc. output reg. }

begin
  if ( hwidth = 8 ) then Regs.BX := $0001     { BH = horiz. direction }
                    else Regs.BX := $0800;     { BL = seq. reg. value }

  x := port[ $3CC ] and not(4+8);                 { Toggle horizontal }
  if ( hwidth = 9 ) then                          { resolution from   }
    x := x or 4;                                  { 720 to 640 pixels }
  port[ $3C2 ] := x;

  Inline($FA);                     {CLI - Toggle sequencer from 8 to 9 pixels }
  portw[ $3C4 ] := $0100;
  portw[ $3C4 ] := { $01 + }(Regs.BL shl 8) + 1;
  portw[ $3C4 ] := $0300;
  Inline($FB);  {STI}

  Regs.AX := $1000;
  Regs.BL := $13;
  intr( $10, Regs );
end;

*)

procedure ResetFont; assembler;
{ Sets the font back to the default 8x16 font }
asm
  mov   ax,     1104h
  mov   bl,     00h
  int   10h
end;

var
  C, D : Word;
begin
  PutFont(128, KWulfLen, KWulf);
  for D := 0 to 4 do
  begin
    for C := 0 to 16 do
      Write(Chr(128 + D + (C * 5)));
    WriteLn;
  end;
  SetCharWidth(8);			{8 pixels per scanline per character}
  ReadLn;
  SetCharWidth(9);			{9 pixels per scanline per character}
  ResetFont;				{Back to the normal font}
end.
